/*
 * Simple client to show how to access ejbs from a client outside
 * the same vm
 * Created on 21.02.2004
 * $Id: WeblogClient.java,v 1.3 2006/10/22 16:50:39 hwr Exp $
 */
package de.bsd.weblog.client;

import java.util.Collection;
import java.util.Date;

import javax.ejb.EJB;
import javax.naming.InitialContext;

import de.bsd.weblog.interfaces.AdminFacade;
import de.bsd.weblog.interfaces.Facade;
import de.bsd.weblog.persistence.Artikel;
import de.bsd.weblog.persistence.Poster;
import de.bsd.weblog.persistence.Weblog;

/**
 * @author hwr@pilhuhn.de
 * @version $Revision: 1.3 $
 */
public class WeblogClient {

	@EJB
	protected static Facade fa;
	
	@EJB
	protected static AdminFacade afa;

	public static void main(String[] args) {
		
		
		try {
			// JNDI Server wird ber jndi.properties bestimmt.
			InitialContext ic = new InitialContext();
			
			if (fa==null) {
				System.out.println("Injection hat nicht funktioniert");
				fa = (Facade)ic.lookup("weblog/FacadeSessionBean/remote");
				afa = (AdminFacade)ic.lookup("weblog/AdminFacadeSessionBean/remote");
			}
			if (fa==null) {
				System.err.println("Kann die Facade nicht ermitteln");
				return;
			}
				
//			fa.initPoster(); // Initale Daten anlegen.
			
			System.out.println("Initale Daten angelegt, zhle Artikel im Blog");
			Date d1 = new Date();
			Date d2 = new Date();
			int count=-1;
			for (int i=0;i<10;i++)
				count = fa.anzahlArtikelInBlog("default");
			
			System.out.println("Artikel gezhlt."); 
			System.out.flush();
				
			Date d3 = new Date();
			
			System.out.println("default contains " + count + " articles");
			System.out.println("Create took " + (d2.getTime()-d1.getTime()) 
					+ " milliseconds");
			System.out.println("Lookup took " + (d3.getTime()-d2.getTime())/10
					+ " miliseconds");
		
			System.out.println("Zhle nun Artikel pro Jahr im Blog 'default'");
			
			Date d4 = new Date();
			count=-1;
			for (int i=0;i<10;i++)
				count = fa.anzahlArtikelProJahr("default",2006);
			
			Date d5 = new Date();
			System.out.println("Ergebnis ist " + count);

			System.out.println("   Lookup took " + (d5.getTime()-d4.getTime())/10
					+ " miliseconds");

			System.out.println("Lege einen neuen Artikel an ");
		
//			Artikel a = new Artikel();
//			a.setDatum(d5);
//			a.setText("Dieser Satz kein Verb. The quick brown fox jumps over the lazy dog."+
//					"Dieser Satz kein Verb. The quick brown fox jumps over the lazy dog."+
//					"Dieser Satz kein Verb. The quick brown fox jumps over the lazy dog."+
//					"Dieser Satz kein Verb. The quick brown fox jumps over the lazy dog."+
//					"Dieser Satz kein Verb. The quick brown fox jumps over the lazy dog."+
//					"Dieser Satz kein Verb. The quick brown fox jumps over the lazy dog."+
//					"Dieser Satz kein Verb. The quick brown fox jumps over the lazy dog."
//					);
//			d4 = new Date();
//			Long artId = fa.artikelHinzufuegen(a,"hwr@pilhuhn.de","default");
//			d5 = new Date();
//
//			System.out.println("addOne took " + (d5.getTime()-d4.getTime())
//					+ " miliseconds");
//			System.out.println("Id des neuen Artikels ist " + artId);
//			
//			count = fa.anzahlArtikelInBlog("default");
//			System.out.println("Das Blog 'default' hat nun " + count + " Artikel");
			
			System.out.println("Vorhandene Blogs: ");
			Collection<Weblog> blogs = fa.listeAlleBlogs();
			for (Weblog blog : blogs)
				System.out.println("  " + blog.getName());
			
			System.out.println("Vorhandene Artikel im Blog 'default'");
			Collection<Artikel> arts = fa.holeAlleArtikelFuerBlog("default");
			for (Artikel art : arts) {
				System.out.println("  ---");
				System.out.println("  Poster: " + art.getPoster().getName());
				System.out.println("  Titel : " + art.getTitel());
				System.out.println("  Text  : " + art.getText());
			}
			
			
			System.out.println("Liste aller Poster im System: "  );
			Collection<Poster> posters = afa.listeAllePoster();
			for (Poster po : posters) {
				System.out.println(" ---");
				System.out.println("  Poster: " + po.getName());
				System.out.println("  EMail : " + po.getEmail());
			}
			
			System.out.println("Ist Poster fuer blog 'default'");
			boolean bp = fa.istPosterFuerBlog("hwr", "default");
			System.out.println("     hwr: " + bp);
			bp = fa.istPosterFuerBlog("admin", "default");
			System.out.println("   admin: " + bp);
			bp = fa.istPosterFuerBlog("nobody", "default");
			System.out.println("  nobody: " + bp);
			
//			System.out.println("Excerpt des Artikels mit der Id " + artId);
//			String ex = fa.holeArtikelExcerpt(artId.toString());
//			System.out.println("len= " + ex.length() + ", text= " + ex );
			
		}
		catch (Exception e) {
			e.printStackTrace();
		}		
	}
}
