/*******************************************************************************
 * Copyright (c) 2006 Heiko W. Rupp.
 * You may use this software as you wish, but you may 
 * not complain if it does not does not do what you want.
 * Or in other words: no warranty included whatsoever.
 *******************************************************************************/
package de.bsd.weblog.interceptors;

import javax.interceptor.AroundInvoke;
import javax.interceptor.InvocationContext;

import org.apache.log4j.Logger;

/**
 * Ein EJB-3.0-Timing-Interceptor. Dieser misst 
 * die Dauer der Aufrufe von EJB-Geschftsmethoden.
 */
public class TimingInterceptor {

	Logger log = Logger.getLogger(TimingInterceptor.class);

	@AroundInvoke
	public Object timing(InvocationContext ctx) throws Exception {
		long t1 = System.currentTimeMillis();
		long now;
		String meth = "";
		try {
			// Aufgerufene Methode extrahieren
			meth = ctx.getMethod().getName();

			// Nchste Methode aufrufen
			return ctx.proceed();
		} finally {
			now = System.currentTimeMillis();
			if (log.isDebugEnabled()) {
				log.debug("Aufruf von " + meth + " dauerte " + (now - t1) + "ms");
			}
		}
	}
}
