package de.bsd.weblog.persistence;

import java.io.Serializable;
import java.util.Date;

import javax.persistence.Entity;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;

@Entity
public class Empfaenger extends Nutzer implements Serializable {
	boolean optIn;
	Date datEintrag;
	
	private static final long serialVersionUID = 1L;
	
	public Empfaenger()
	{ 
		optIn = false;
	}
	
	/**
	 * Datum des initialen Eintrags
	 * @return the datEintrag
	 */
	@Temporal(TemporalType.DATE)
	public Date getDatEintrag() {
		return datEintrag;
	}

	public void setDatEintrag(Date datEintrag) {
		this.datEintrag = datEintrag;
	}
	
	/**
	 * Kam die Opt-In-Antwort zurck?
	 * @return the optIn
	 */
	public boolean isOptIn() {
		return optIn;
	}
	public void setOptIn(boolean optIn) {
		this.optIn = optIn;
	}
}
