package de.bsd.weblog.persistence;

import java.io.Serializable;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.EnumType;
import javax.persistence.Enumerated;
import javax.persistence.Id;
import javax.persistence.Inheritance;
import javax.persistence.InheritanceType;
import javax.persistence.Table;

@Entity
@Table(name="WL_NUTZER")
@Inheritance(strategy=InheritanceType.SINGLE_TABLE)
public abstract class Nutzer implements Serializable {
	int id;
	String email;
	String passwort;
	NRolle rolle;
	int version;
	
	private static final long serialVersionUID = 1L;

	protected Nutzer() 
	{ 
		// Fr JPA
	}
	
	protected Nutzer(String email)
	{
		setEmail(email);
	}


	/**
	 * E-Mail des Benutzers. Diese
	 * dient auch als Primrschlssel und muss
	 * eindeutig sein.
	 * @return the email
	 */
	@Id
	@Column(length=64)
	public String getEmail() {
		return email;
	}

	private void setEmail(String email) {
		this.email = email;
	}
	
	/**
	 * Passwort des Nutzers
	 * @return the passwort
	 */
	@Column(length=32)
	public String getPasswort() {
		return passwort;
	}

	public void setPasswort(String passwd) {
		this.passwort = passwd;
	}
	/**
	 * Rolle des Benutzers. 
	 * Diese wird in der DB als String
	 * abgelegt.
	 * @return the rolle
	 */
	@Column(length=12)
	@Enumerated(EnumType.STRING)
	public NRolle getRolle() {
		return rolle;
	}
	
	public void setRolle(NRolle rolle) {
		this.rolle = rolle;
	}
	/**
	 * Versionsspalte fr
	 * Optimistic Locking
	 * @return the version
	 */
	public int getVersion() {
		return version;
	}

	@SuppressWarnings("unused")
	private void setVersion(int version) {
		this.version = version;
	}
	
}
